within ;
package cv2
  expandable connector buscon

  end buscon;

  model A

    buscon buscon1
      annotation (Placement(transformation(extent={{-78,58},{-58,78}})));
    Modelica.Blocks.Continuous.Integrator integrator
      annotation (Placement(transformation(extent={{0,2},{20,22}})));
  equation
    connect(integrator.y, buscon1.etadlo) annotation (Line(
        points={{21,12},{22,12},{22,68},{-68,68}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(integrator.u, buscon1.int_inp) annotation (Line(
        points={{-2,12},{-34,12},{-34,68},{-68,68}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}), graphics));
  end A;

  model B

    buscon buscon1
      annotation (Placement(transformation(extent={{-20,-4},{0,16}})));
    Modelica.Blocks.Sources.Sine sine(freqHz=1)
      annotation (Placement(transformation(extent={{-88,4},{-68,24}})));
    Modelica.Blocks.Math.Gain gain(k=1)
      annotation (Placement(transformation(extent={{-34,54},{-14,74}})));
    A a annotation (Placement(transformation(extent={{36,-16},{56,4}})));
  equation
    connect(sine.y, buscon1.int_inp) annotation (Line(
        points={{-67,14},{-40,14},{-40,6},{-10,6}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(gain.u, buscon1.etadlo) annotation (Line(
        points={{-36,64},{-38,64},{-38,6},{-10,6}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(buscon1, a.buscon1) annotation (Line(
        points={{-10,6},{15,6},{15,0.8},{39.2,0.8}},
        color={0,0,0},
        smooth=Smooth.None), Text(
        string="%first",
        index=-1,
        extent={{-6,3},{-6,3}}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}), graphics));
  end B;

  model testbus
    A a annotation (Placement(transformation(extent={{-82,36},{-62,56}})));
    B b annotation (Placement(transformation(extent={{42,36},{62,56}})));
  equation
    connect(a.buscon1, b.buscon1) annotation (Line(
        points={{-78.8,52.8},{-13.4,52.8},{-13.4,46.6},{51,46.6}},
        color={0,0,0},
        smooth=Smooth.None));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{
              -100,-100},{100,100}}), graphics));
  end testbus;
  annotation (uses(Modelica(version="3.2.1")));
  function fc
    input Real a;
    input Real b;
    output Real c;
  protected
    Real d=a^2;
  algorithm
    c := d + b;
  end fc;

  model testfun
    Real out;
    parameter Real k=4;
  equation
    out = fc(k, time);
  end testfun;
end cv2;
